;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module string
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _strlen
	.globl _strrev
	.globl _int_to_ascii
	.globl _hex_to_ascii
	.globl _append
	.globl _backspace
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;libc/string.c:7: char* strrev(char* str) {
;	---------------------------------
; Function strrev
; ---------------------------------
_strrev::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	dec	sp
;libc/string.c:10: for (i=0,j=strlen(str)-1;i<j;i++,j--) {
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_strlen
	pop	af
	ld	c, l
	ld	b, h
	dec	bc
	ld	de, #0x0000
00103$:
	ld	a, e
	sub	a, c
	ld	a, d
	sbc	a, b
	jp	PO, 00118$
	xor	a, #0x80
00118$:
	jp	P, 00101$
;libc/string.c:11: chr=str[i];
	ld	a, 4 (ix)
	add	a, e
	ld	-3 (ix), a
	ld	a, 5 (ix)
	adc	a, d
	ld	-2 (ix), a
	pop	hl
	push	hl
	ld	a, (hl)
	ld	-1 (ix), a
;libc/string.c:12: str[i]=str[j];
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	pop	iy
	pop	hl
	add	iy, bc
	ld	a, 0 (iy)
	pop	hl
	push	hl
	ld	(hl), a
;libc/string.c:13: str[j]=chr;
	ld	a, -1 (ix)
	ld	0 (iy), a
;libc/string.c:10: for (i=0,j=strlen(str)-1;i<j;i++,j--) {
	inc	de
	dec	bc
	jr	00103$
00101$:
;libc/string.c:15: return str;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
;libc/string.c:16: }
	ld	sp, ix
	pop	ix
	ret
;libc/string.c:18: void int_to_ascii(int n,char* str) {
;	---------------------------------
; Function int_to_ascii
; ---------------------------------
_int_to_ascii::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;libc/string.c:21: if ((sign = n)<0) {
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	a, b
	rlca
	and	a,#0x01
	ld	-1 (ix), a
	or	a, a
	jr	Z,00111$
;libc/string.c:22: n=-n;
	ld	hl, #0x0000
	cp	a, a
	sbc	hl, bc
	ld	4 (ix), l
	ld	5 (ix), h
;libc/string.c:25: do {
00111$:
	ld	de, #0x0000
00103$:
;libc/string.c:26: str[i++]=n%10+'0';
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	add	hl, de
	inc	de
	push	hl
	push	de
	ld	bc, #0x000a
	push	bc
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	push	bc
	call	__modsint
	pop	af
	pop	af
	ld	c, l
	pop	de
	pop	hl
	ld	a, c
	add	a, #0x30
	ld	(hl), a
;libc/string.c:27: } while ((n /= 10) > 0);
	push	de
	ld	hl, #0x000a
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	__divsint
	pop	af
	pop	af
	pop	de
	ld	4 (ix), l
	ld	5 (ix), h
	xor	a, a
	cp	a, l
	sbc	a, h
	jp	PO, 00131$
	xor	a, #0x80
00131$:
	jp	M, 00103$
;libc/string.c:28: if (sign < 0) {
	ld	c, e
	ld	b, d
	ld	a, -1 (ix)
	or	a, a
	jr	Z,00107$
;libc/string.c:29: str[i++] = '-';
	ld	c, e
	ld	b, d
	inc	bc
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	add	hl, de
	ld	(hl), #0x2d
00107$:
;libc/string.c:31: str[i]='\0';
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	add	hl, bc
	ld	(hl), #0x00
;libc/string.c:32: strrev(str);
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	call	_strrev
	pop	af
;libc/string.c:33: }
	inc	sp
	pop	ix
	ret
;libc/string.c:35: void hex_to_ascii(int n, char* str) {
;	---------------------------------
; Function hex_to_ascii
; ---------------------------------
_hex_to_ascii::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;libc/string.c:36: str[0]='\0';
	ld	c, 6 (ix)
	ld	b, 7 (ix)
	xor	a, a
	ld	(bc), a
;libc/string.c:37: append(str, '0');
	push	bc
	ld	a, #0x30
	push	af
	inc	sp
	push	bc
	call	_append
	pop	af
	inc	sp
	ld	a, #0x78
	push	af
	inc	sp
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	call	_append
	pop	af
	inc	sp
	pop	bc
;libc/string.c:39: char zeros = 0;
	ld	-2 (ix), #0x00
;libc/string.c:43: for (i = 28; i > 0; i -= 4) {
	ld	de, #0x001c
00112$:
;libc/string.c:44: tmp = (n >> i) & 0xF;
	ld	a, e
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	inc	a
	jr	00142$
00141$:
	sra	h
	rr	l
00142$:
	dec	a
	jr	NZ, 00141$
	ld	a, l
	and	a, #0x0f
	ld	l, a
	ld	h, #0x00
;libc/string.c:45: if (tmp == 0 && zeros == 0) continue;
	ld	a, h
	or	a, l
	jr	NZ,00102$
	ld	a, -2 (ix)
	or	a, a
	jr	Z,00107$
00102$:
;libc/string.c:46: zeros = 1;
	ld	-2 (ix), #0x01
;libc/string.c:47: if (tmp >= 0xA) append(str, tmp - 0xA + 'a');
	ld	-1 (ix), l
	ld	a, l
	sub	a, #0x0a
	ld	a, h
	sbc	a, #0x00
	jr	C,00105$
	ld	a, -1 (ix)
	add	a, #0x57
	push	bc
	push	de
	push	af
	inc	sp
	push	bc
	call	_append
	pop	af
	inc	sp
	pop	de
	pop	bc
	jr	00107$
00105$:
;libc/string.c:48: else append(str, tmp + '0');
	ld	a, -1 (ix)
	add	a, #0x30
	push	bc
	push	de
	push	af
	inc	sp
	push	bc
	call	_append
	pop	af
	inc	sp
	pop	de
	pop	bc
00107$:
;libc/string.c:43: for (i = 28; i > 0; i -= 4) {
	ld	a, e
	add	a, #0xfc
	ld	e, a
	ld	a, d
	adc	a, #0xff
	ld	d, a
	xor	a, a
	cp	a, e
	sbc	a, d
	jp	PO, 00143$
	xor	a, #0x80
00143$:
	jp	M, 00112$
;libc/string.c:51: tmp = n & 0xF;
	ld	a, 4 (ix)
	and	a, #0x0f
	ld	e, a
	ld	d, #0x00
;libc/string.c:47: if (tmp >= 0xA) append(str, tmp - 0xA + 'a');
;libc/string.c:52: if (tmp >= 0xA) append(str, tmp - 0xA + 'a');
	ld	a,e
	ld	l,a
	sub	a, #0x0a
	ld	a, d
	sbc	a, #0x00
	jr	C,00110$
	ld	a, l
	add	a, #0x57
	push	af
	inc	sp
	push	bc
	call	_append
	pop	af
	inc	sp
	jr	00113$
00110$:
;libc/string.c:53: else append(str, tmp + '0');
	ld	a, l
	add	a, #0x30
	push	af
	inc	sp
	push	bc
	call	_append
	pop	af
	inc	sp
00113$:
;libc/string.c:54: }
	ld	sp, ix
	pop	ix
	ret
;libc/string.c:56: void append(char* s, char n) {
;	---------------------------------
; Function append
; ---------------------------------
_append::
;libc/string.c:57: int len = strlen(s);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_strlen
	pop	af
	ld	c, l
	ld	b, h
;libc/string.c:58: s[len] = n;
	ld	hl, #2
	add	hl, sp
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, bc
	ld	iy, #4
	add	iy, sp
	ld	a, 0 (iy)
	ld	(hl), a
;libc/string.c:59: s[len+1] = '\0';
	inc	bc
	ld	hl, #2
	add	hl, sp
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, bc
	ld	(hl), #0x00
;libc/string.c:60: }
	ret
;libc/string.c:62: void backspace(char* s) {
;	---------------------------------
; Function backspace
; ---------------------------------
_backspace::
;libc/string.c:63: int len = strlen(s);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_strlen
	pop	af
	ld	c, l
	ld	b, h
;libc/string.c:64: s[len-1] = '\0';
	dec	bc
	ld	hl, #2
	add	hl, sp
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, bc
	ld	(hl), #0x00
;libc/string.c:65: }
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
