;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module asincosf
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _asincosf
	.globl _ldexpf
	.globl _fabsf
	.globl _sqrtf
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../asincosf.c:47: float asincosf(float x, bool isacos)
;	---------------------------------
; Function asincosf
; ---------------------------------
_asincosf::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-13
	add	hl, sp
	ld	sp, hl
;../asincosf.c:51: bool quartPI = isacos;
	ld	a, 8 (ix)
	ld	-1 (ix), a
;../asincosf.c:56: y = fabsf(x);
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_fabsf
	pop	af
	pop	af
	ld	-13 (ix), l
	ld	-12 (ix), h
	ld	-11 (ix), e
	ld	-10 (ix), d
;../asincosf.c:57: if (y < EPS)
	ld	hl, #0x3980
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	a, l
	or	a, a
	jr	Z,00107$
;../asincosf.c:59: r = y;
	ld	c, -13 (ix)
	ld	b, -12 (ix)
	ld	e, -11 (ix)
	ld	d, -10 (ix)
	jp	00108$
00107$:
;../asincosf.c:63: if (y > 0.5)
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	hl, #0x3f00
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	or	a, a
	jp	Z, 00104$
;../asincosf.c:65: quartPI = !isacos;
	ld	a, -1 (ix)
	xor	a, #0x01
	ld	-1 (ix), a
;../asincosf.c:66: if (y > 1.0)
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00102$
;../asincosf.c:68: errno = EDOM;
	ld	hl, #0x0021
	ld	(_errno), hl
;../asincosf.c:69: return 0.0;
	ld	hl,#0x0000
	ld	e,l
	ld	d,h
	jp	00117$
00102$:
;../asincosf.c:71: g = (0.5 - y) + 0.5;
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
;../asincosf.c:72: g = ldexpf(g, -1);
	ld	hl, #0xffff
	push	hl
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	call	_ldexpf
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	hl, #4
	add	hl, sp
	ex	de, hl
	ld	hl, #8
	add	hl, sp
	ld	bc, #4
	ldir
;../asincosf.c:73: y = sqrtf(g);
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	push	hl
	call	_sqrtf
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
;../asincosf.c:74: y = -(y + y);
	ld	-3 (ix), e
	ld	-2 (ix), d
	push	de
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	a, d
	xor	a,#0x80
	ld	-10 (ix), a
	ld	a, -5 (ix)
	ld	-13 (ix), a
	ld	a, -4 (ix)
	ld	-12 (ix), a
	ld	a, -3 (ix)
	ld	-11 (ix), a
	jr	00105$
00104$:
;../asincosf.c:78: g = y * y;
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-9 (ix), l
	ld	-8 (ix), h
	ld	-7 (ix), e
	ld	-6 (ix), d
00105$:
;../asincosf.c:80: r = y + y * ((P(g) * g) / Q(g));
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	push	hl
	ld	hl, #0xbf01
	push	hl
	ld	hl, #0x2065
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0x3f6f
	push	hl
	ld	hl, #0x166b
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	push	hl
	push	de
	push	bc
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	hl, #0xc0b1
	push	hl
	ld	hl, #0x8d0b
	push	hl
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	push	hl
	push	de
	push	bc
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0x40b3
	push	hl
	ld	hl, #0x50f0
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
00108$:
;../asincosf.c:82: i = quartPI;
;../asincosf.c:85: if (x < 0.0)
	push	bc
	push	de
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
;../asincosf.c:86: r = (b[i] + r) + b[i];
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	pop	de
	pop	bc
	ld	l, -1 (ix)
	ld	h, #0x00
	add	hl, hl
	add	hl, hl
	ld	-2 (ix), l
	ld	-1 (ix), h
;../asincosf.c:83: if (isacos)
	bit	0, 8 (ix)
	jp	Z, 00115$
;../asincosf.c:85: if (x < 0.0)
	ld	a, -5 (ix)
	or	a, a
	jr	Z,00110$
;../asincosf.c:86: r = (b[i] + r) + b[i];
	ld	a, -2 (ix)
	add	a, #<(_asincosf_b_65536_26)
	ld	l, a
	ld	a, -1 (ix)
	adc	a, #>(_asincosf_b_65536_26)
	ld	h, a
	push	de
	push	bc
	ex	de,hl
	ld	hl, #0x000d
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	jp	00116$
00110$:
;../asincosf.c:88: r = (a[i] - r) + a[i];
	ld	a, -2 (ix)
	add	a, #<(_asincosf_a_65536_26)
	ld	l, a
	ld	a, -1 (ix)
	adc	a, #>(_asincosf_a_65536_26)
	ld	h, a
	push	de
	push	bc
	ex	de,hl
	ld	hl, #0x000d
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	jr	00116$
00115$:
;../asincosf.c:92: r = (a[i] + r) + a[i];
	ld	a, #<(_asincosf_a_65536_26)
	add	a, -2 (ix)
	ld	l, a
	ld	a, #>(_asincosf_a_65536_26)
	adc	a, -1 (ix)
	ld	h, a
	push	de
	push	bc
	ex	de,hl
	ld	hl, #0x000d
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
;../asincosf.c:93: if (x < 0.0)
	ld	a, -5 (ix)
	or	a, a
	jr	Z,00116$
;../asincosf.c:94: r = -r;
	ld	a, -1 (ix)
	xor	a,#0x80
	ld	-1 (ix), a
00116$:
;../asincosf.c:96: return r;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
00117$:
;../asincosf.c:97: }
	ld	sp, ix
	pop	ix
	ret
_asincosf_a_65536_26:
	.byte #0x00, #0x00, #0x00, #0x00	;  0.000000e+00
	.byte #0xdb, #0x0f, #0x49, #0x3f	;  7.853982e-01
_asincosf_b_65536_26:
	.byte #0xdb, #0x0f, #0xc9, #0x3f	;  1.570796e+00
	.byte #0xdb, #0x0f, #0x49, #0x3f	;  7.853982e-01
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
