;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module mblen
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _mblen
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../mblen.c:31: int mblen(const char *s, size_t n)
;	---------------------------------
; Function mblen
; ---------------------------------
_mblen::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;../mblen.c:36: if(!s)
	ld	a, 5 (ix)
	or	a, 4 (ix)
	jr	NZ,00102$
;../mblen.c:37: return(0);
	ld	hl, #0x0000
	jr	00119$
00102$:
;../mblen.c:39: if(!n)
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	NZ,00104$
;../mblen.c:40: return(-1);
	ld	hl, #0xffff
	jr	00119$
00104$:
;../mblen.c:42: c = *s;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	c, (hl)
;../mblen.c:44: if(!c)
	ld	a, c
	or	a, a
	jr	NZ,00106$
;../mblen.c:45: return(0);
	ld	hl, #0x0000
	jr	00119$
00106$:
;../mblen.c:47: if(c <= 0x7f)
	ld	a, #0x7f
	sub	a, c
	jr	C,00126$
;../mblen.c:48: return(1);
	ld	hl, #0x0001
	jr	00119$
;../mblen.c:50: while(c & 0x80)
00126$:
	ld	e, #0x00
00109$:
	bit	7, c
	jr	Z,00111$
;../mblen.c:52: c <<= 1;
	sla	c
;../mblen.c:53: m++;
	inc	e
	jr	00109$
00111$:
;../mblen.c:56: if(m > n)
	ld	c, e
	ld	b, #0x00
	ld	a, 6 (ix)
	sub	a, c
	ld	a, 7 (ix)
	sbc	a, b
	jr	NC,00129$
;../mblen.c:57: return(-1);
	ld	hl, #0xffff
	jr	00119$
;../mblen.c:60: while(--m)
00129$:
	ld	-1 (ix), e
00116$:
	dec	-1 (ix)
	ld	a, -1 (ix)
	or	a, a
	jr	Z,00118$
;../mblen.c:61: if((*++s & 0xc0) != 0x80)
	inc	hl
	ld	a, (hl)
	and	a, #0xc0
	ld	e, a
	ld	d, #0x00
	ld	a, e
	sub	a, #0x80
	or	a, d
	jr	Z,00116$
;../mblen.c:62: return(-1);
	ld	hl, #0xffff
	jr	00119$
00118$:
;../mblen.c:64: return(n);
	ld	l, c
	ld	h, b
00119$:
;../mblen.c:65: }
	inc	sp
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
