;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module mbtowc
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _mbtowc
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../mbtowc.c:31: int mbtowc(wchar_t *pwc, const char *restrict s, size_t n)
;	---------------------------------
; Function mbtowc
; ---------------------------------
_mbtowc::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-12
	add	hl, sp
	ld	sp, hl
;../mbtowc.c:37: if(!s)
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	NZ,00102$
;../mbtowc.c:38: return(0);
	ld	hl, #0x0000
	jp	00124$
00102$:
;../mbtowc.c:40: seqlen = 1;
	ld	c, #0x01
;../mbtowc.c:41: first_byte = *s;
	ld	a, 6 (ix)
	ld	-7 (ix), a
	ld	a, 7 (ix)
	ld	-6 (ix), a
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	ld	a, (hl)
	ld	-1 (ix), a
;../mbtowc.c:43: if(first_byte & 0x80)
	bit	7, -1 (ix)
	jr	Z,00107$
;../mbtowc.c:45: while (first_byte & (0x80 >> seqlen))
	ld	c, #0x01
00103$:
	ld	b, c
	ld	de, #0x0080
	inc	b
	jr	00196$
00195$:
	sra	d
	rr	e
00196$:
	djnz	00195$
	ld	a, -1 (ix)
	ld	-5 (ix), a
	ld	-4 (ix), #0x00
;../mbtowc.c:46: seqlen++;
	ld	l, c
	inc	l
;../mbtowc.c:45: while (first_byte & (0x80 >> seqlen))
	ld	a, -5 (ix)
	and	a, e
	ld	-3 (ix), a
	ld	a, -4 (ix)
	and	a, d
	ld	-2 (ix), a
	or	a, -3 (ix)
	jr	Z,00140$
;../mbtowc.c:46: seqlen++;
	ld	c, l
	jr	00103$
00140$:
;../mbtowc.c:47: first_byte &= (0xff >> (seqlen + 1));
	ld	b, #0xff
	ld	e, #0x00
	inc	l
	jr	00198$
00197$:
	sra	e
	rr	b
00198$:
	dec	l
	jr	NZ, 00197$
	ld	a, b
	and	a, -1 (ix)
	ld	-1 (ix), a
00107$:
;../mbtowc.c:50: if(seqlen > 4 || n < seqlen)
	ld	a, #0x04
	sub	a, c
	jr	C,00108$
	ld	b, c
	ld	e, #0x00
	ld	a, 8 (ix)
	sub	a, b
	ld	a, 9 (ix)
	sbc	a, e
	jr	NC,00134$
00108$:
;../mbtowc.c:51: return(-1);
	ld	hl, #0xffff
	jp	00124$
;../mbtowc.c:53: for(i = 1; i < seqlen; i++)
00134$:
	ld	e, #0x01
00119$:
	ld	a, e
	sub	a, c
	jr	NC,00113$
;../mbtowc.c:54: if((s[i] & 0xc0) != 0x80)
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	ld	d, #0x00
	add	hl, de
	ld	l, (hl)
	ld	h, #0x00
	ld	a, l
	and	a, #0xc0
	ld	l, a
	ld	b, #0x00
	ld	a, l
	sub	a, #0x80
	or	a, b
	jr	Z,00120$
;../mbtowc.c:55: return(-1);
	ld	hl, #0xffff
	jp	00124$
00120$:
;../mbtowc.c:53: for(i = 1; i < seqlen; i++)
	inc	e
	jr	00119$
00113$:
;../mbtowc.c:57: codepoint = first_byte;
	ld	a, -1 (ix)
	ld	-4 (ix), a
	ld	-3 (ix), #0x00
	ld	-2 (ix), #0x00
	ld	-1 (ix), #0x00
;../mbtowc.c:59: for(s++, i = seqlen - 1; i; i--)
	ld	a, -7 (ix)
	add	a, #0x01
	ld	6 (ix), a
	ld	a, -6 (ix)
	adc	a, #0x00
	ld	7 (ix), a
	ld	e, c
	dec	e
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	pop	iy
	pop	hl
00122$:
	ld	a, e
	or	a, a
	jr	Z,00114$
;../mbtowc.c:61: codepoint <<= 6;
	ld	a, -4 (ix)
	ld	-12 (ix), a
	ld	a, -3 (ix)
	ld	-11 (ix), a
	ld	a, -2 (ix)
	ld	-10 (ix), a
	ld	a, -1 (ix)
	ld	-9 (ix), a
	ld	b, #0x06
00200$:
	sla	-12 (ix)
	rl	-11 (ix)
	rl	-10 (ix)
	rl	-9 (ix)
	djnz	00200$
;../mbtowc.c:62: codepoint |= (*s & 0x3f);
	ld	a, 0 (iy)
	and	a, #0x3f
	ld	l, a
	ld	h, #0x00
	ld	-8 (ix), l
	ld	a, h
	ld	-7 (ix), a
	rla
	sbc	a, a
	ld	-6 (ix), a
	ld	-5 (ix), a
	ld	a, -12 (ix)
	or	a, -8 (ix)
	ld	-4 (ix), a
	ld	a, -11 (ix)
	or	a, -7 (ix)
	ld	-3 (ix), a
	ld	a, -10 (ix)
	or	a, -6 (ix)
	ld	-2 (ix), a
	ld	a, -9 (ix)
	or	a, -5 (ix)
	ld	-1 (ix), a
;../mbtowc.c:63: s++;
	inc	iy
;../mbtowc.c:59: for(s++, i = seqlen - 1; i; i--)
	dec	e
	jr	00122$
00114$:
;../mbtowc.c:66: if(codepoint >= 0xd800 && codepoint <= 0xdfff) // UTF-16 surrogate.
	ld	a, -3 (ix)
	sub	a, #0xd8
	ld	a, -2 (ix)
	sbc	a, #0x00
	ld	a, -1 (ix)
	sbc	a, #0x00
	jr	C,00116$
	ld	a, #0xff
	cp	a, -4 (ix)
	ld	a, #0xdf
	sbc	a, -3 (ix)
	ld	a, #0x00
	sbc	a, -2 (ix)
	ld	a, #0x00
	sbc	a, -1 (ix)
	jr	C,00116$
;../mbtowc.c:67: return(-1);
	ld	hl, #0xffff
	jr	00124$
00116$:
;../mbtowc.c:69: *pwc = codepoint;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	push	bc
	ld	hl, #0x000a
	add	hl, sp
	ld	bc, #0x0004
	ldir
	pop	bc
;../mbtowc.c:70: return(codepoint ? seqlen : 0);
	ld	a, -1 (ix)
	or	a, -2 (ix)
	or	a, -3 (ix)
	or	a, -4 (ix)
	jr	Z,00126$
	ld	l, c
	ld	h, #0x00
	jr	00127$
00126$:
	ld	hl, #0x0000
00127$:
00124$:
;../mbtowc.c:71: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
