#ifndef TASKING_H
#define TASKING_H

#include <stdint.h>

typedef struct {
  uint16_t bank_table[4];
  uint16_t pc_or_sp;
  uint8_t flags;
  int16_t next_task;
  int16_t prev_task;
} Task;

void tasking_new(void* pc,uint16_t bank_table[4]);
void tasking_yield();
void tasking_init();

#endif
