;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module _fsdiv
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl ___fsdiv
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
;../_fsdiv.c:349: float __fsdiv (float a1, float a2)
;	---------------------------------
; Function __fsdiv
; ---------------------------------
___fsdiv::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;../_fsdiv.c:352: unsigned long *p = (unsigned long *) &f;
	ld	hl, #0
	add	hl, sp
	ld	b, l
	ld	c, h
;../_fsdiv.c:354: if (a2 == 0.0f && a1 > 0.0f)
	ld	a, 11 (ix)
	res	7, a
	or	a, 10 (ix)
	or	a, 9 (ix)
	or	a, 8 (ix)
	jr	NZ,00110$
	push	bc
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	pop	bc
	or	a, a
	jr	Z,00110$
;../_fsdiv.c:355: *p = 0x7f800000; // inf
	ld	l, b
	ld	h, c
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), #0x80
	inc	hl
	ld	(hl), #0x7f
	jp	00111$
00110$:
;../_fsdiv.c:356: else if (a2 == 0.0f && a1 < 0.0f)
	ld	a, 11 (ix)
	res	7, a
	or	a, 10 (ix)
	or	a, 9 (ix)
	or	a, 8 (ix)
	jr	NZ,00106$
	push	bc
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	pop	bc
	or	a, a
	jr	Z,00106$
;../_fsdiv.c:357: *p = 0xff800000; // -inf
	ld	l, b
	ld	h, c
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), #0x80
	inc	hl
	ld	(hl), #0xff
	jr	00111$
00106$:
;../_fsdiv.c:358: else if (a2 == 0.0f && a1 == 0.0f)
	ld	a, 11 (ix)
	res	7, a
	or	a, 10 (ix)
	or	a, 9 (ix)
	or	a, 8 (ix)
	jr	NZ,00102$
	ld	a, 7 (ix)
	res	7, a
	or	a, 6 (ix)
	or	a, 5 (ix)
	or	a, 4 (ix)
	jr	NZ,00102$
;../_fsdiv.c:359: *p = 0xffc00000; // nan
	ld	l, b
	ld	h, c
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), #0xc0
	inc	hl
	ld	(hl), #0xff
	jr	00111$
00102$:
;../_fsdiv.c:361: f = __fsdiv_org (a1, a2);
	ld	l, 10 (ix)
	ld	h, 11 (ix)
	push	hl
	ld	l, 8 (ix)
	ld	h, 9 (ix)
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fsdiv_org
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
00111$:
;../_fsdiv.c:363: return f; 
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
;../_fsdiv.c:364: }
	ld	sp, ix
	pop	ix
	ret
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../_fsdiv.c:274: static float __fsdiv_org (float a1, float a2)
;	---------------------------------
; Function __fsdiv_org
; ---------------------------------
___fsdiv_org:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-36
	add	hl, sp
	ld	sp, hl
;../_fsdiv.c:283: fl1.f = a1;
	ld	hl, #0
	add	hl, sp
	ex	de, hl
	ld	hl, #0x0028
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../_fsdiv.c:284: fl2.f = a2;
	ld	hl, #4
	add	hl, sp
	ex	de, hl
	ld	hl, #0x002c
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../_fsdiv.c:287: exp = EXP (fl1.l) ;
	ld	hl, #0
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	b, #0x07
00174$:
	srl	d
	rr	e
	djnz	00174$
	ld	-2 (ix), e
	ld	-1 (ix), #0x00
;../_fsdiv.c:288: exp -= EXP (fl2.l);
	ld	hl, #4
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	b, #0x07
00176$:
	srl	d
	rr	e
	djnz	00176$
	ld	d, #0x00
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	cp	a, a
	sbc	hl, de
	ld	-2 (ix), l
	ld	-1 (ix), h
;../_fsdiv.c:289: exp += EXCESS;
	ld	a, -2 (ix)
	add	a, #0x7e
	ld	-2 (ix), a
	jr	NC,00178$
	inc	-1 (ix)
00178$:
;../_fsdiv.c:292: sign = SIGN (fl1.l) ^ SIGN (fl2.l);
	ld	hl, #0
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	a, (hl)
	rlc	a
	and	a, #0x01
	ld	-15 (ix), a
	ld	hl, #4
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, d
	rlc	a
	and	a, #0x01
	xor	a, -15 (ix)
	ld	c, a
;../_fsdiv.c:295: if (!fl2.l)
	ld	hl, #4
	add	hl, sp
	ex	de, hl
	push	bc
	ld	hl, #0x0014
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	pop	bc
	ld	a, -15 (ix)
	or	a, -16 (ix)
	or	a, -17 (ix)
	or	a, -18 (ix)
	jr	NZ,00102$
;../_fsdiv.c:297: fl2.l = 0x7FC00000;
	ld	hl, #4
	add	hl, sp
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), #0xc0
	inc	hl
	ld	(hl), #0x7f
;../_fsdiv.c:298: return (fl2.f);
	ld	hl, #4
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	jp	00118$
00102$:
;../_fsdiv.c:302: if (!fl1.l)
	ld	hl, #0
	add	hl, sp
	ld	b, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	ld	a, (hl)
	inc	hl
	or	a, (hl)
	or	a, d
	or	a, b
	jr	NZ,00104$
;../_fsdiv.c:303: return (0);
	ld	hl,#0x0000
	ld	e,l
	ld	d,h
	jp	00118$
00104$:
;../_fsdiv.c:306: mant1 = MANT (fl1.l);
	ld	hl, #0
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, b
	res	7, l
	ld	b, #0x00
	ld	-6 (ix), e
	ld	-5 (ix), d
	ld	a, l
	or	a, #0x80
	ld	-4 (ix), a
	ld	-3 (ix), b
;../_fsdiv.c:307: mant2 = MANT (fl2.l);
	ld	hl, #4
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, b
	res	7, l
	ld	b, #0x00
	ld	-28 (ix), e
	ld	-27 (ix), d
	ld	a, l
	or	a, #0x80
	ld	-26 (ix), a
	ld	-25 (ix), b
;../_fsdiv.c:310: if (mant1 < mant2)
	ld	a, -6 (ix)
	sub	a, -28 (ix)
	ld	a, -5 (ix)
	sbc	a, -27 (ix)
	ld	a, -4 (ix)
	sbc	a, -26 (ix)
	ld	a, -3 (ix)
	sbc	a, -25 (ix)
	jp	PO, 00179$
	xor	a, #0x80
00179$:
	jp	P, 00106$
;../_fsdiv.c:312: mant1 <<= 1;
	sla	-6 (ix)
	rl	-5 (ix)
	rl	-4 (ix)
	rl	-3 (ix)
;../_fsdiv.c:313: exp--;
	ld	a, -2 (ix)
	ld	e, -1 (ix)
	add	a, #0xff
	ld	-2 (ix), a
	ld	a, e
	adc	a, #0xff
	ld	-1 (ix), a
00106$:
;../_fsdiv.c:317: mask = 0x1000000;
	ld	-10 (ix), #0x00
	ld	-9 (ix), #0x00
	ld	-8 (ix), #0x00
	ld	-7 (ix), #0x01
;../_fsdiv.c:318: result = 0;
	xor	a, a
	ld	-14 (ix), a
	ld	-13 (ix), a
	ld	-12 (ix), a
	ld	-11 (ix), a
;../_fsdiv.c:319: while (mask)
00109$:
	ld	a, -7 (ix)
	or	a, -8 (ix)
	or	a, -9 (ix)
	or	a, -10 (ix)
	jp	Z, 00111$
;../_fsdiv.c:321: if (mant1 >= mant2)
	ld	a, -6 (ix)
	sub	a, -28 (ix)
	ld	a, -5 (ix)
	sbc	a, -27 (ix)
	ld	a, -4 (ix)
	sbc	a, -26 (ix)
	ld	a, -3 (ix)
	sbc	a, -25 (ix)
	jp	PO, 00182$
	xor	a, #0x80
00182$:
	jp	M, 00108$
;../_fsdiv.c:323: result |= mask;
	ld	b, -14 (ix)
	ld	h, -13 (ix)
	ld	e, -12 (ix)
	ld	d, -11 (ix)
	ld	a, b
	or	a, -10 (ix)
	ld	l, a
	ld	a, h
	or	a, -9 (ix)
	ld	h, a
	ld	a, e
	or	a, -8 (ix)
	ld	e, a
	ld	a, d
	or	a, -7 (ix)
	ld	d, a
	ld	-14 (ix), l
	ld	-13 (ix), h
	ld	-12 (ix), e
	ld	-11 (ix), d
;../_fsdiv.c:324: mant1 -= mant2;
	ld	a, -6 (ix)
	sub	a, -28 (ix)
	ld	-6 (ix), a
	ld	a, -5 (ix)
	sbc	a, -27 (ix)
	ld	-5 (ix), a
	ld	a, -4 (ix)
	sbc	a, -26 (ix)
	ld	-4 (ix), a
	ld	a, -3 (ix)
	sbc	a, -25 (ix)
	ld	-3 (ix), a
00108$:
;../_fsdiv.c:326: mant1 <<= 1;
	sla	-6 (ix)
	rl	-5 (ix)
	rl	-4 (ix)
	rl	-3 (ix)
;../_fsdiv.c:327: mask >>= 1;
	srl	-7 (ix)
	rr	-8 (ix)
	rr	-9 (ix)
	rr	-10 (ix)
	jp	00109$
00111$:
;../_fsdiv.c:331: result += 1;
	inc	-14 (ix)
	jr	NZ,00187$
	inc	-13 (ix)
	jr	NZ,00187$
	inc	-12 (ix)
	jr	NZ,00187$
	inc	-11 (ix)
00187$:
;../_fsdiv.c:334: exp++;
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	inc	de
	ld	-2 (ix), e
	ld	-1 (ix), d
;../_fsdiv.c:335: result >>= 1;
	sra	-11 (ix)
	rr	-12 (ix)
	rr	-13 (ix)
	rr	-14 (ix)
;../_fsdiv.c:337: result &= ~HIDDEN;
	ld	a, -14 (ix)
	ld	-14 (ix), a
	ld	a, -13 (ix)
	ld	-13 (ix), a
	ld	a, -12 (ix)
	and	a, #0x7f
	ld	-12 (ix), a
	ld	a, -11 (ix)
	ld	-11 (ix), a
;../_fsdiv.c:340: if (exp >= 0x100)
	ld	a, -1 (ix)
	xor	a, #0x80
	sub	a, #0x81
	jr	C,00116$
;../_fsdiv.c:341: fl1.l = (sign ? SIGNBIT : 0) | __INFINITY;
	ld	hl, #0
	add	hl, sp
	ld	a, c
	or	a, a
	jr	Z,00120$
	ld	bc, #0x0000
	ld	de, #0x8000
	jr	00121$
00120$:
	ld	bc, #0x0000
	ld	de, #0x0000
00121$:
	set	7, e
	ld	a, d
	or	a, #0x7f
	ld	d, a
	ld	(hl), c
	inc	hl
	ld	(hl), b
	inc	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
	jp	00117$
00116$:
;../_fsdiv.c:342: else if (exp < 0)
	bit	7, -1 (ix)
	jr	Z,00113$
;../_fsdiv.c:343: fl1.l = 0;
	ld	hl, #0
	add	hl, sp
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), #0x00
	jp	00117$
00113$:
;../_fsdiv.c:345: fl1.l = PACK (sign ? SIGNBIT : 0 , exp, result);
	ld	hl, #0
	add	hl, sp
	ld	-24 (ix), l
	ld	-23 (ix), h
	ld	a, c
	or	a, a
	jr	Z,00122$
	ld	-22 (ix), #0x00
	ld	-21 (ix), #0x00
	ld	-20 (ix), #0x00
	ld	-19 (ix), #0x80
	jr	00123$
00122$:
	xor	a, a
	ld	-22 (ix), a
	ld	-21 (ix), a
	ld	-20 (ix), a
	ld	-19 (ix), a
00123$:
	ld	l, -2 (ix)
	ld	a, -1 (ix)
	ld	h, a
	rla
	sbc	a, a
	ld	de, #0x0000
	ld	b, #0x07
00190$:
	add	hl, hl
	djnz	00190$
	ld	a, -22 (ix)
	or	a, e
	ld	-18 (ix), a
	ld	a, -21 (ix)
	or	a, d
	ld	-17 (ix), a
	ld	a, -20 (ix)
	or	a, l
	ld	-16 (ix), a
	ld	a, -19 (ix)
	or	a, h
	ld	-15 (ix), a
	ld	c, -14 (ix)
	ld	b, -13 (ix)
	ld	e, -12 (ix)
	ld	d, -11 (ix)
	ld	a, c
	or	a, -18 (ix)
	ld	c, a
	ld	a, b
	or	a, -17 (ix)
	ld	b, a
	ld	a, e
	or	a, -16 (ix)
	ld	e, a
	ld	a, d
	or	a, -15 (ix)
	ld	d, a
	ld	l, -24 (ix)
	ld	h, -23 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
	inc	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
00117$:
;../_fsdiv.c:346: return (fl1.f);
	ld	hl, #0
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
00118$:
;../_fsdiv.c:347: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
