;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module _modslonglong
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl __modslonglong
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
;../_modslonglong.c:36: _modslonglong (long long numerator, long long denominator)
;	---------------------------------
; Function _modslonglong
; ---------------------------------
__modslonglong::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-17
	add	hl, sp
	ld	sp, hl
;../_modslonglong.c:38: bool numeratorneg = (numerator < 0);
	ld	a, 13 (ix)
	rlca
	and	a,#0x01
	ld	-1 (ix), a
;../_modslonglong.c:39: bool denominatorneg = (denominator < 0);
	ld	a, 21 (ix)
	rlca
	and	a,#0x01
	ld	c, a
;../_modslonglong.c:42: if (numeratorneg)
	bit	0, -1 (ix)
	jr	Z,00102$
;../_modslonglong.c:43: numerator = -numerator;
	xor	a, a
	sub	a, 6 (ix)
	ld	6 (ix), a
	ld	a, #0x00
	sbc	a, 7 (ix)
	ld	7 (ix), a
	ld	a, #0x00
	sbc	a, 8 (ix)
	ld	8 (ix), a
	ld	a, #0x00
	sbc	a, 9 (ix)
	ld	9 (ix), a
	ld	a, #0x00
	sbc	a, 10 (ix)
	ld	10 (ix), a
	ld	a, #0x00
	sbc	a, 11 (ix)
	ld	11 (ix), a
	ld	a, #0x00
	sbc	a, 12 (ix)
	ld	12 (ix), a
	ld	a, #0x00
	sbc	a, 13 (ix)
	ld	13 (ix), a
00102$:
;../_modslonglong.c:44: if (denominatorneg)
	bit	0, c
	jr	Z,00104$
;../_modslonglong.c:45: denominator = -denominator;
	xor	a, a
	sub	a, 14 (ix)
	ld	14 (ix), a
	ld	a, #0x00
	sbc	a, 15 (ix)
	ld	15 (ix), a
	ld	a, #0x00
	sbc	a, 16 (ix)
	ld	16 (ix), a
	ld	a, #0x00
	sbc	a, 17 (ix)
	ld	17 (ix), a
	ld	a, #0x00
	sbc	a, 18 (ix)
	ld	18 (ix), a
	ld	a, #0x00
	sbc	a, 19 (ix)
	ld	19 (ix), a
	ld	a, #0x00
	sbc	a, 20 (ix)
	ld	20 (ix), a
	ld	a, #0x00
	sbc	a, 21 (ix)
	ld	21 (ix), a
00104$:
;../_modslonglong.c:47: r = (unsigned long long)numerator % (unsigned long long)denominator;
	ld	hl, #0
	add	hl, sp
	ex	de, hl
	ld	hl, #23
	add	hl, sp
	ld	bc, #8
	ldir
	ld	hl, #8
	add	hl, sp
	ex	de, hl
	ld	hl, #31
	add	hl, sp
	ld	bc, #8
	ldir
	ld	c, -3 (ix)
	ld	b, -2 (ix)
	push	bc
	ld	c, -5 (ix)
	ld	b, -4 (ix)
	push	bc
	ld	c, -7 (ix)
	ld	b, -6 (ix)
	push	bc
	ld	c, -9 (ix)
	ld	b, -8 (ix)
	push	bc
	ld	c, -11 (ix)
	ld	b, -10 (ix)
	push	bc
	ld	c, -13 (ix)
	ld	b, -12 (ix)
	push	bc
	ld	c, -15 (ix)
	ld	b, -14 (ix)
	push	bc
	ld	c, -17 (ix)
	ld	b, -16 (ix)
	push	bc
	ld	hl, #0x0018
	add	hl, sp
	push	hl
	call	__modulonglong
	ld	hl, #18
	add	hl, sp
	ld	sp, hl
;../_modslonglong.c:49: return (numeratorneg ? -r : r);
	bit	0, -1 (ix)
	jr	Z,00107$
	xor	a, a
	sub	a, -9 (ix)
	ld	-17 (ix), a
	ld	a, #0x00
	sbc	a, -8 (ix)
	ld	-16 (ix), a
	ld	a, #0x00
	sbc	a, -7 (ix)
	ld	-15 (ix), a
	ld	a, #0x00
	sbc	a, -6 (ix)
	ld	-14 (ix), a
	ld	a, #0x00
	sbc	a, -5 (ix)
	ld	-13 (ix), a
	ld	a, #0x00
	sbc	a, -4 (ix)
	ld	-12 (ix), a
	ld	a, #0x00
	sbc	a, -3 (ix)
	ld	-11 (ix), a
	ld	a, #0x00
	sbc	a, -2 (ix)
	ld	-10 (ix), a
	jr	00108$
00107$:
	ld	hl, #0
	add	hl, sp
	ex	de, hl
	ld	hl, #8
	add	hl, sp
	ld	bc, #8
	ldir
00108$:
	ld	hl, #21
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	hl, #0
	add	hl, sp
	ld	bc, #8
	ldir
;../_modslonglong.c:50: }
	ld	sp, ix
	pop	ix
	ret
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
