;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module malloc
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl ___sdcc_heap_init
	.globl ___sdcc_heap_free
	.globl _malloc
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
___sdcc_heap_free::
	.ds 2
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../malloc.c:65: void __sdcc_heap_init(void)
;	---------------------------------
; Function __sdcc_heap_init
; ---------------------------------
___sdcc_heap_init::
;../malloc.c:67: __sdcc_heap_free = HEAP_START;
	ld	hl, #___sdcc_heap+0
	ld	(___sdcc_heap_free), hl
;../malloc.c:68: __sdcc_heap_free->next = HEAP_END;
	ld	bc, (___sdcc_heap_free)
	ld	a, #<(___sdcc_heap_end)
	ld	(bc), a
	inc	bc
	ld	a, #>(___sdcc_heap_end)
	ld	(bc), a
;../malloc.c:69: __sdcc_heap_free->next_free = 0;
	ld	hl, (___sdcc_heap_free)
	inc	hl
	inc	hl
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;../malloc.c:70: }
	ret
;../malloc.c:75: void *malloc(size_t size)
;	---------------------------------
; Function malloc
; ---------------------------------
_malloc::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;../malloc.c:86: if(!size || size + offsetof(struct header, next_free) < size)
	ld	a, 5 (ix)
	or	a, 4 (ix)
	jr	Z,00101$
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	inc	bc
	inc	bc
	ld	a, c
	sub	a, 4 (ix)
	ld	a, b
	sbc	a, 5 (ix)
	jr	NC,00102$
00101$:
;../malloc.c:87: return(0);
	ld	hl, #0x0000
	jp	00115$
00102$:
;../malloc.c:88: size += offsetof(struct header, next_free);
	ld	4 (ix), c
	ld	5 (ix), b
;../malloc.c:89: if(size < sizeof(struct header)) // Requiring a minimum size makes it easier to implement free(), and avoid memory leaks.
	ld	a, 4 (ix)
	sub	a, #0x04
	ld	a, 5 (ix)
	sbc	a, #0x00
	jr	NC,00105$
;../malloc.c:90: size = sizeof(struct header);
	ld	4 (ix), #0x04
	ld	5 (ix), #0x00
00105$:
;../malloc.c:92: for(h = __sdcc_heap_free, f = &__sdcc_heap_free; h; f = &(h->next_free), h = h->next_free)
	ld	bc, (___sdcc_heap_free)
	ld	-8 (ix), #<(___sdcc_heap_free)
	ld	-7 (ix), #>(___sdcc_heap_free)
00113$:
	ld	a, b
	or	a, c
	jp	Z, 00111$
;../malloc.c:94: size_t blocksize = (char HEAPSPACE *)(h->next) - (char HEAPSPACE *)h;
	ld	a, (bc)
	ld	-6 (ix), a
	inc	bc
	ld	a, (bc)
	ld	-5 (ix), a
	dec	bc
	pop	de
	pop	hl
	push	hl
	push	de
	ld	e, c
	ld	d, b
	cp	a, a
	sbc	hl, de
;../malloc.c:101: newheader->next_free = h->next_free;
	ld	a, c
	add	a, #0x02
	ld	-4 (ix), a
	ld	a, b
	adc	a, #0x00
	ld	-3 (ix), a
;../malloc.c:95: if(blocksize >= size) // Found free block of sufficient size.
	ld	a, l
	sub	a, 4 (ix)
	ld	a, h
	sbc	a, 5 (ix)
	jr	C,00114$
;../malloc.c:97: if(blocksize >= size + sizeof(struct header)) // It is worth creating a new free block
	ld	a, 4 (ix)
	add	a, #0x04
	ld	-2 (ix), a
	ld	a, 5 (ix)
	adc	a, #0x00
	ld	-1 (ix), a
	ld	a, l
	sub	a, -2 (ix)
	ld	a, h
	sbc	a, -1 (ix)
	jr	C,00107$
;../malloc.c:99: header_t *const newheader = (header_t *const)((char HEAPSPACE *)h + size);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	add	hl, de
;../malloc.c:100: newheader->next = h->next;
	ld	e,l
	ld	d,h
	ld	a, -6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -5 (ix)
	ld	(hl), a
;../malloc.c:101: newheader->next_free = h->next_free;
	push	de
	pop	iy
	inc	iy
	inc	iy
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	0 (iy), a
	ld	1 (iy), h
;../malloc.c:102: *f = newheader;
	pop	hl
	push	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
;../malloc.c:103: h->next = newheader;
	ld	a, e
	ld	(bc), a
	inc	bc
	ld	a, d
	ld	(bc), a
	jr	00108$
00107$:
;../malloc.c:106: *f = h->next_free;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	pop	hl
	push	hl
	ld	(hl), c
	inc	hl
	ld	(hl), b
00108$:
;../malloc.c:108: return(&(h->next_free));
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	jr	00115$
00114$:
;../malloc.c:92: for(h = __sdcc_heap_free, f = &__sdcc_heap_free; h; f = &(h->next_free), h = h->next_free)
	ld	a, -4 (ix)
	ld	-8 (ix), a
	ld	a, -3 (ix)
	ld	-7 (ix), a
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	jp	00113$
00111$:
;../malloc.c:112: return(0);
	ld	hl, #0x0000
00115$:
;../malloc.c:113: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
