;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module printf_large
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _strlen
	.globl __print_format
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../printf_large.c:116: output_digit (unsigned char n, bool lower_case, pfn_outputchar output_char, void* p)
;	---------------------------------
; Function output_digit
; ---------------------------------
_output_digit:
;../printf_large.c:118: register unsigned char c = n + (unsigned char)'0';
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	add	a, #0x30
	ld	b, a
;../printf_large.c:120: if (c > (unsigned char)'9')
	ld	a, #0x39
	sub	a, b
	jr	NC,00104$
;../printf_large.c:122: c += (unsigned char)('A' - '0' - 10);
	ld	a, b
	add	a, #0x07
	ld	b, a
;../printf_large.c:123: if (lower_case)
	ld	hl, #3+0
	add	hl, sp
	bit	0, (hl)
	jr	Z,00104$
;../printf_large.c:124: c += (unsigned char)('a' - 'A');
	ld	a, b
	add	a, #0x20
	ld	b, a
00104$:
;../printf_large.c:126: output_char( c, p );
	ld	hl, #6
	add	hl, sp
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	hl
	push	bc
	inc	sp
	ld	hl, #7
	add	hl, sp
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	call	___sdcc_call_hl
	pop	af
	inc	sp
;../printf_large.c:127: }
	ret
;../printf_large.c:149: output_2digits (unsigned char b, bool lower_case, pfn_outputchar output_char, void* p)
;	---------------------------------
; Function output_2digits
; ---------------------------------
_output_2digits:
	push	ix
	ld	ix,#0
	add	ix,sp
;../printf_large.c:151: output_digit( b>>4,   lower_case, output_char, p );
	ld	a, 4 (ix)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
	ld	b, a
	ld	l, 8 (ix)
	ld	h, 9 (ix)
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, 5 (ix)
	push	af
	inc	sp
	push	bc
	inc	sp
	call	_output_digit
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;../printf_large.c:152: output_digit( b&0x0F, lower_case, output_char, p );
	ld	a, 4 (ix)
	and	a, #0x0f
	ld	b, a
	ld	l, 8 (ix)
	ld	h, 9 (ix)
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, 5 (ix)
	push	af
	inc	sp
	push	bc
	inc	sp
	call	_output_digit
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;../printf_large.c:153: }
	pop	ix
	ret
;../printf_large.c:168: calculate_digit (value_t _AUTOMEM * value, unsigned char radix)
;	---------------------------------
; Function calculate_digit
; ---------------------------------
_calculate_digit:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-7
	add	hl, sp
	ld	sp, hl
;../printf_large.c:170: unsigned long ul = value->ul;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	push	de
	ld	hl, #0x0005
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	pop	de
;../printf_large.c:171: unsigned char _AUTOMEM * pb4 = &value->byte[4];
	ld	hl, #0x0004
	add	hl, de
	ld	c, l
	ld	b, h
;../printf_large.c:172: unsigned char i = 32;
	ld	-6 (ix), #0x20
;../printf_large.c:174: do
00103$:
;../printf_large.c:176: *pb4 = (*pb4 << 1) | ((ul >> 31) & 0x01);
	ld	a, (bc)
	add	a, a
	ld	-7 (ix), a
	ld	a, -1 (ix)
	rlc	a
	and	a, #0x01
	ld	-5 (ix), a
	ld	a, -7 (ix)
	or	a, -5 (ix)
	ld	-5 (ix), a
	ld	(bc),a
;../printf_large.c:177: ul <<= 1;
	sla	-4 (ix)
	rl	-3 (ix)
	rl	-2 (ix)
	rl	-1 (ix)
;../printf_large.c:179: if (radix <= *pb4 )
	ld	a, -5 (ix)
	sub	a, 6 (ix)
	jr	C,00104$
;../printf_large.c:181: *pb4 -= radix;
	ld	a, (bc)
	sub	a, 6 (ix)
	ld	(bc), a
;../printf_large.c:182: ul |= 1;
	ld	a, -4 (ix)
	or	a, #0x01
	ld	-4 (ix), a
	ld	a, -3 (ix)
	ld	-3 (ix), a
	ld	a, -2 (ix)
	ld	-2 (ix), a
	ld	a, -1 (ix)
	ld	-1 (ix), a
00104$:
;../printf_large.c:184: } while (--i);
	dec	-6 (ix)
	ld	a, -6 (ix)
	or	a, a
	jr	NZ,00103$
;../printf_large.c:185: value->ul = ul;
	ld	hl, #0x0003
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../printf_large.c:186: }
	ld	sp, ix
	pop	ix
	ret
;../printf_large.c:434: _print_format (pfn_outputchar pfn, void* pvoid, const char *format, va_list ap)
;	---------------------------------
; Function _print_format
; ---------------------------------
__print_format::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-51
	add	hl, sp
	ld	sp, hl
;../printf_large.c:466: charsOutputted = 0;
	ld	-6 (ix), #0x00
	ld	-5 (ix), #0x00
;../printf_large.c:475: while( c=*format++ )
	ld	hl, #8
	add	hl, sp
	ld	-32 (ix), l
	ld	-31 (ix), h
	ld	hl, #18
	add	hl, sp
	ld	-30 (ix), l
	ld	-29 (ix), h
	ld	hl, #8
	add	hl, sp
	ld	-28 (ix), l
	ld	-27 (ix), h
	ld	a, -28 (ix)
	add	a, #0x04
	ld	-26 (ix), a
	ld	a, -27 (ix)
	adc	a, #0x00
	ld	-25 (ix), a
	ld	a, -26 (ix)
	ld	-24 (ix), a
	ld	a, -25 (ix)
	ld	-23 (ix), a
	ld	a, -26 (ix)
	ld	-22 (ix), a
	ld	a, -25 (ix)
	ld	-21 (ix), a
00231$:
	ld	l, 8 (ix)
	ld	h, 9 (ix)
	ld	e, (hl)
	inc	hl
	ld	8 (ix), l
	ld	9 (ix), h
	ld	-1 (ix), e
	ld	a, e
	or	a, a
	jp	Z, 00233$
;../printf_large.c:477: if ( c=='%' )
	ld	a, -1 (ix)
	sub	a, #0x25
	jp	NZ,00229$
;../printf_large.c:479: left_justify    = 0;
	ld	-20 (ix), #0x00
;../printf_large.c:480: zero_padding    = 0;
	ld	-19 (ix), #0x00
;../printf_large.c:481: prefix_sign     = 0;
	ld	-18 (ix), #0x00
;../printf_large.c:482: prefix_space    = 0;
	ld	-17 (ix), #0x00
;../printf_large.c:483: signed_argument = 0;
	ld	-16 (ix), #0x00
;../printf_large.c:484: char_argument   = 0;
	ld	-15 (ix), #0x00
;../printf_large.c:485: long_argument   = 0;
	ld	-14 (ix), #0x00
;../printf_large.c:486: float_argument  = 0;
	ld	-13 (ix), #0x00
;../printf_large.c:487: radix           = 0;
	ld	-12 (ix), #0x00
;../printf_large.c:488: width           = 0;
	ld	-4 (ix), #0x00
	ld	-3 (ix), #0x00
;../printf_large.c:489: decimals        = -1;
	ld	-11 (ix), #0xff
	ld	-10 (ix), #0xff
;../printf_large.c:491: get_conversion_spec:
	ld	a, 8 (ix)
	ld	-8 (ix), a
	ld	a, 9 (ix)
	ld	-7 (ix), a
00101$:
;../printf_large.c:493: c = *format++;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	a, (hl)
	ld	-1 (ix), a
	inc	-8 (ix)
	jr	NZ,00629$
	inc	-7 (ix)
00629$:
	ld	a, -8 (ix)
	ld	8 (ix), a
	ld	a, -7 (ix)
	ld	9 (ix), a
;../printf_large.c:495: if (c=='%')
	ld	a, -1 (ix)
	sub	a, #0x25
	jr	NZ,00103$
;../printf_large.c:497: OUTPUT_CHAR(c, p);
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, -1 (ix)
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jp	NZ,00231$
	inc	-5 (ix)
;../printf_large.c:498: continue;
	jp	00231$
00103$:
;../printf_large.c:501: if (isdigit(c))
	ld	a, -1 (ix)
	sub	a, #0x30
	jr	C,00110$
	ld	a, #0x39
	sub	a, -1 (ix)
	jr	C,00110$
;../printf_large.c:503: if (decimals==-1)
	ld	a, -11 (ix)
	inc	a
	jr	NZ,00107$
	ld	a, -10 (ix)
	inc	a
	jr	NZ,00107$
;../printf_large.c:505: width = 10*width + c - '0';
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	-45 (ix), l
	ld	-44 (ix), h
	ld	a, -1 (ix)
	ld	-2 (ix), a
	ld	-1 (ix), #0x00
	ld	c, a
	ld	b, #0x00
	ld	l, -45 (ix)
	ld	h, -44 (ix)
	add	hl, bc
	ld	a, l
	add	a, #0xd0
	ld	-4 (ix), a
	ld	a, h
	adc	a, #0xff
;../printf_large.c:506: if (width == 0)
	ld	-3 (ix), a
	or	a, -4 (ix)
	jp	NZ, 00101$
;../printf_large.c:509: zero_padding = 1;
	ld	-19 (ix), #0x01
	jp	00101$
00107$:
;../printf_large.c:514: decimals = 10*decimals + c - '0';
	ld	c, -11 (ix)
	ld	b, -10 (ix)
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	c, -1 (ix)
	ld	b, #0x00
	add	hl, bc
	ld	a, l
	add	a, #0xd0
	ld	-11 (ix), a
	ld	a, h
	adc	a, #0xff
	ld	-10 (ix), a
;../printf_large.c:516: goto get_conversion_spec;
	jp	00101$
00110$:
;../printf_large.c:519: if (c=='.')
	ld	a, -1 (ix)
	sub	a, #0x2e
	jr	NZ,00115$
;../printf_large.c:521: if (decimals==-1)
	ld	a, -11 (ix)
	inc	a
	jp	NZ,00101$
	ld	a, -10 (ix)
	inc	a
	jp	NZ,00101$
;../printf_large.c:522: decimals=0;
	ld	-11 (ix), #0x00
	ld	-10 (ix), #0x00
;../printf_large.c:525: goto get_conversion_spec;
	jp	00101$
00115$:
;../printf_large.c:528: if (islower(c))
	ld	a, -1 (ix)
	sub	a, #0x61
	jr	C,00117$
	ld	a, #0x7a
	sub	a, -1 (ix)
	jr	C,00117$
;../printf_large.c:530: c = toupper(c);
	ld	a, -1 (ix)
	and	a, #0xdf
	ld	-1 (ix), a
;../printf_large.c:531: lower_case = 1;
	ld	-9 (ix), #0x01
	jr	00118$
00117$:
;../printf_large.c:534: lower_case = 0;
	ld	-9 (ix), #0x00
00118$:
;../printf_large.c:536: switch( c )
	ld	a, -1 (ix)
	sub	a, #0x20
	jp	Z,00122$
	ld	a, -1 (ix)
	sub	a, #0x2b
	jp	Z,00121$
	ld	a, -1 (ix)
	sub	a, #0x2d
	jr	Z,00120$
	ld	a, -1 (ix)
	sub	a, #0x42
	jp	Z,00123$
	ld	a, -1 (ix)
	sub	a, #0x43
	jp	Z,00129$
	ld	a, -1 (ix)
	sub	a, #0x44
	jp	Z,00154$
	ld	a, -1 (ix)
	sub	a, #0x46
	jp	Z,00158$
	ld	a, -1 (ix)
	sub	a, #0x48
	jp	Z,00101$
	ld	a, -1 (ix)
	sub	a, #0x49
	jp	Z,00154$
	ld	a, -1 (ix)
	sub	a, #0x4a
	jp	Z,00101$
	ld	a, -1 (ix)
	sub	a, #0x4c
	jr	Z,00128$
	ld	a, -1 (ix)
	sub	a, #0x4f
	jp	Z,00155$
	ld	a, -1 (ix)
	sub	a, #0x50
	jp	Z,00152$
	ld	a, -1 (ix)
	sub	a, #0x53
	jp	Z,00133$
	ld	a, -1 (ix)
	sub	a, #0x54
	jp	Z,00101$
	ld	a, -1 (ix)
	sub	a, #0x55
	jp	Z,00156$
	ld	a, -1 (ix)
	sub	a, #0x58
	jp	Z,00157$
	ld	a, -1 (ix)
	sub	a, #0x5a
	jp	Z,00101$
	jp	00159$
;../printf_large.c:538: case '-':
00120$:
;../printf_large.c:539: left_justify = 1;
	ld	-20 (ix), #0x01
;../printf_large.c:540: goto get_conversion_spec;
	jp	00101$
;../printf_large.c:541: case '+':
00121$:
;../printf_large.c:542: prefix_sign = 1;
	ld	-18 (ix), #0x01
;../printf_large.c:543: goto get_conversion_spec;
	jp	00101$
;../printf_large.c:544: case ' ':
00122$:
;../printf_large.c:545: prefix_space = 1;
	ld	-17 (ix), #0x01
;../printf_large.c:546: goto get_conversion_spec;
	jp	00101$
;../printf_large.c:547: case 'B': /* byte */
00123$:
;../printf_large.c:548: char_argument = 1;
	ld	-15 (ix), #0x01
;../printf_large.c:549: goto get_conversion_spec;
	jp	00101$
;../printf_large.c:556: case 'L': /* long */
00128$:
;../printf_large.c:557: long_argument = 1;
	ld	-14 (ix), #0x01
;../printf_large.c:558: goto get_conversion_spec;
	jp	00101$
;../printf_large.c:560: case 'C':
00129$:
;../printf_large.c:561: if( char_argument )
	bit	0, -15 (ix)
	jr	Z,00131$
;../printf_large.c:562: c = va_arg(ap,char);
	ld	l, 10 (ix)
	ld	h, 11 (ix)
	inc	hl
	ld	10 (ix), l
	ld	11 (ix), h
	dec	hl
	ld	b, (hl)
	jr	00132$
00131$:
;../printf_large.c:564: c = va_arg(ap,int);
	ld	l, 10 (ix)
	ld	h, 11 (ix)
	inc	hl
	inc	hl
	ld	10 (ix), l
	ld	11 (ix), h
	dec	hl
	dec	hl
	ld	b, (hl)
00132$:
;../printf_large.c:565: OUTPUT_CHAR( c, p );
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	push	bc
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jp	NZ,00160$
	inc	-5 (ix)
;../printf_large.c:566: break;
	jp	00160$
;../printf_large.c:568: case 'S':
00133$:
;../printf_large.c:569: PTR = va_arg(ap,ptr_t);
	ld	hl, #8
	add	hl, sp
	ld	-8 (ix), l
	ld	-7 (ix), h
	ld	l, 10 (ix)
	ld	h, 11 (ix)
	inc	hl
	inc	hl
	ld	10 (ix), l
	ld	11 (ix), h
	dec	hl
	dec	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
;../printf_large.c:582: length = strlen(PTR);
	push	bc
	call	_strlen
	pop	af
	ld	c, l
	ld	b, h
;../printf_large.c:584: if ( decimals == -1 )
	ld	a, -11 (ix)
	inc	a
	jr	NZ,00135$
	ld	a, -10 (ix)
	inc	a
	jr	NZ,00135$
;../printf_large.c:586: decimals = length;
	ld	-11 (ix), c
	ld	-10 (ix), b
00135$:
;../printf_large.c:588: if ( ( !left_justify ) && (length < width) )
	bit	0, -20 (ix)
	jr	NZ,00277$
	ld	a, c
	sub	a, -4 (ix)
	ld	a, b
	sbc	a, -3 (ix)
	jr	NC,00277$
;../printf_large.c:590: width -= length;
	ld	a, -4 (ix)
	sub	a, c
	ld	-2 (ix), a
	ld	a, -3 (ix)
	sbc	a, b
	ld	-1 (ix), a
;../printf_large.c:591: while( width-- != 0 )
	ld	e, -6 (ix)
	ld	d, -5 (ix)
00136$:
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, -2 (ix)
	add	a, #0xff
	ld	-2 (ix), a
	ld	a, -1 (ix)
	adc	a, #0xff
	ld	-1 (ix), a
	ld	a, h
	or	a, l
	jr	Z,00312$
;../printf_large.c:593: OUTPUT_CHAR( ' ', p );
	push	bc
	push	de
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x20
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	pop	de
	pop	bc
	inc	de
	jr	00136$
;../printf_large.c:597: while ( (c = *PTR)  && (decimals-- > 0))
00312$:
	ld	-6 (ix), e
	ld	-5 (ix), d
	ld	a, -2 (ix)
	ld	-4 (ix), a
	ld	a, -1 (ix)
	ld	-3 (ix), a
00277$:
	ld	a, -11 (ix)
	ld	-2 (ix), a
	ld	a, -10 (ix)
	ld	-1 (ix), a
	ld	e, -6 (ix)
	ld	d, -5 (ix)
00143$:
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	a, (hl)
	ld	-5 (ix), a
	or	a, a
	jr	Z,00313$
	xor	a, a
	cp	a, -2 (ix)
	sbc	a, -1 (ix)
	jp	PO, 00660$
	xor	a, #0x80
00660$:
	jp	P, 00313$
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	dec	hl
	ld	-2 (ix), l
	ld	-1 (ix), h
;../printf_large.c:599: OUTPUT_CHAR( c, p );
	push	bc
	push	de
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, -5 (ix)
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	pop	de
	pop	bc
	inc	de
;../printf_large.c:600: PTR++;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	inc	hl
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	a, -6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -5 (ix)
	ld	(hl), a
	jr	00143$
00313$:
	ld	-6 (ix), e
	ld	-5 (ix), d
;../printf_large.c:603: if ( left_justify && (length < width))
	bit	0, -20 (ix)
	jp	Z, 00160$
	ld	a, c
	sub	a, -4 (ix)
	ld	a, b
	sbc	a, -3 (ix)
	jp	NC, 00160$
;../printf_large.c:605: width -= length;
	ld	a, -4 (ix)
	sub	a, c
	ld	c, a
	ld	a, -3 (ix)
	sbc	a, b
	ld	b, a
;../printf_large.c:606: while( width-- != 0 )
00146$:
	ld	l, c
	ld	h, b
	dec	bc
	ld	a, h
	or	a, l
	jp	Z, 00314$
;../printf_large.c:608: OUTPUT_CHAR( ' ', p );
	push	bc
	push	de
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x20
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	pop	de
	pop	bc
	inc	de
	jr	00146$
;../printf_large.c:613: case 'P':
00152$:
;../printf_large.c:614: PTR = va_arg(ap,ptr_t);
	ld	hl, #8
	add	hl, sp
	ex	de, hl
	ld	l, 10 (ix)
	ld	h, 11 (ix)
	inc	hl
	inc	hl
	ld	10 (ix), l
	ld	11 (ix), h
	dec	hl
	dec	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, c
	ld	(de), a
	inc	de
	ld	a, b
	ld	(de), a
;../printf_large.c:658: OUTPUT_CHAR('0', p);
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x30
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	inc	bc
;../printf_large.c:659: OUTPUT_CHAR('x', p);
	push	bc
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x78
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	pop	bc
	inc	bc
;../printf_large.c:660: OUTPUT_2DIGITS( value.byte[1] );
	ld	hl, #9
	add	hl, sp
	ld	d, (hl)
	push	bc
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	ld	a, -9 (ix)
	push	af
	inc	sp
	push	de
	inc	sp
	call	_output_2digits
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
	inc	bc
	inc	bc
;../printf_large.c:661: OUTPUT_2DIGITS( value.byte[0] );
	ld	l, -32 (ix)
	ld	h, -31 (ix)
	ld	d, (hl)
	push	bc
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	ld	a, -9 (ix)
	push	af
	inc	sp
	push	de
	inc	sp
	call	_output_2digits
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
	inc	bc
	inc	bc
	ld	-6 (ix), c
	ld	-5 (ix), b
;../printf_large.c:663: break;
	jr	00160$
;../printf_large.c:666: case 'I':
00154$:
;../printf_large.c:667: signed_argument = 1;
	ld	-16 (ix), #0x01
;../printf_large.c:668: radix = 10;
	ld	-12 (ix), #0x0a
;../printf_large.c:669: break;
	jr	00160$
;../printf_large.c:671: case 'O':
00155$:
;../printf_large.c:672: radix = 8;
	ld	-12 (ix), #0x08
;../printf_large.c:673: break;
	jr	00160$
;../printf_large.c:675: case 'U':
00156$:
;../printf_large.c:676: radix = 10;
	ld	-12 (ix), #0x0a
;../printf_large.c:677: break;
	jr	00160$
;../printf_large.c:679: case 'X':
00157$:
;../printf_large.c:680: radix = 16;
	ld	-12 (ix), #0x10
;../printf_large.c:681: break;
	jr	00160$
;../printf_large.c:683: case 'F':
00158$:
;../printf_large.c:684: float_argument=1;
	ld	-13 (ix), #0x01
;../printf_large.c:685: break;
	jr	00160$
;../printf_large.c:687: default:
00159$:
;../printf_large.c:689: OUTPUT_CHAR( c, p );
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, -1 (ix)
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jr	NZ,00160$
	inc	-5 (ix)
;../printf_large.c:872: return charsOutputted;
	jr	00160$
;../printf_large.c:691: }
00314$:
	ld	-6 (ix), e
	ld	-5 (ix), d
	ld	-4 (ix), c
	ld	-3 (ix), b
00160$:
;../printf_large.c:693: if (float_argument)
	bit	0, -13 (ix)
	jp	Z, 00226$
;../printf_large.c:695: value.f = va_arg(ap, float);
	ld	hl, #8
	add	hl, sp
	ld	-8 (ix), l
	ld	-7 (ix), h
	ld	a, 10 (ix)
	add	a, #0x04
	ld	-4 (ix), a
	ld	a, 11 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
	ld	a, -4 (ix)
	ld	10 (ix), a
	ld	a, -3 (ix)
	ld	11 (ix), a
	ld	a, -4 (ix)
	add	a, #0xfc
	ld	-2 (ix), a
	ld	a, -3 (ix)
	adc	a, #0xff
	ld	-1 (ix), a
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x002f
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	ld	hl, #0x002f
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../printf_large.c:697: PTR="<NO FLOAT>";
	ld	hl, #8
	add	hl, sp
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	(hl), #<(___str_0)
	inc	hl
	ld	(hl), #>(___str_0)
;../printf_large.c:698: while (c=*PTR++)
	ld	a, -6 (ix)
	ld	-2 (ix), a
	ld	a, -5 (ix)
	ld	-1 (ix), a
00161$:
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	e, c
	ld	d, b
	inc	de
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), d
	ld	a, (bc)
	ld	b, a
	or	a, a
	jp	Z, 00231$
;../printf_large.c:700: OUTPUT_CHAR (c, p);
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	push	bc
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-2 (ix)
	jr	NZ,00662$
	inc	-1 (ix)
00662$:
	ld	a, -2 (ix)
	ld	-6 (ix), a
	ld	a, -1 (ix)
	ld	-5 (ix), a
	jr	00161$
00226$:
;../printf_large.c:718: else if (radix != 0)
	ld	a, -12 (ix)
	or	a, a
	jp	Z, 00231$
;../printf_large.c:723: unsigned char MEM_SPACE_BUF_PP *pstore = &store[5];
	ld	a, -30 (ix)
	ld	-8 (ix), a
	ld	a, -29 (ix)
	ld	-7 (ix), a
;../printf_large.c:726: if (char_argument)
	bit	0, -15 (ix)
	jp	Z, 00172$
;../printf_large.c:728: value.l = va_arg(ap, char);
	ld	hl, #8
	add	hl, sp
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, 10 (ix)
	add	a, #0x01
	ld	-11 (ix), a
	ld	a, 11 (ix)
	adc	a, #0x00
	ld	-10 (ix), a
	ld	a, -11 (ix)
	ld	10 (ix), a
	ld	a, -10 (ix)
	ld	11 (ix), a
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	dec	hl
	ld	a, (hl)
	ld	-10 (ix), a
	ld	-47 (ix), a
	ld	-46 (ix), #0x00
	ld	-45 (ix), #0x00
	ld	-44 (ix), #0x00
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0004
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../printf_large.c:729: if (!signed_argument)
	bit	0, -16 (ix)
	jp	NZ, 00173$
;../printf_large.c:731: value.l &= 0xFF;
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0000
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	ld	a, -51 (ix)
	ld	-47 (ix), a
	ld	-46 (ix), #0x00
	ld	-45 (ix), #0x00
	ld	-44 (ix), #0x00
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0004
	add	hl, sp
	ld	bc, #0x0004
	ldir
	jp	00173$
00172$:
;../printf_large.c:734: else if (long_argument)
	bit	0, -14 (ix)
	jr	Z,00169$
;../printf_large.c:736: value.l = va_arg(ap, long);
	ld	hl, #8
	add	hl, sp
	ld	-11 (ix), l
	ld	-10 (ix), h
	ld	a, 10 (ix)
	add	a, #0x04
	ld	-14 (ix), a
	ld	a, 11 (ix)
	adc	a, #0x00
	ld	-13 (ix), a
	ld	a, -14 (ix)
	ld	10 (ix), a
	ld	a, -13 (ix)
	ld	11 (ix), a
	ld	a, -14 (ix)
	add	a, #0xfc
	ld	-2 (ix), a
	ld	a, -13 (ix)
	adc	a, #0xff
	ld	-1 (ix), a
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0004
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	ld	e, -11 (ix)
	ld	d, -10 (ix)
	ld	hl, #0x0004
	add	hl, sp
	ld	bc, #0x0004
	ldir
	jp	00173$
00169$:
;../printf_large.c:740: value.l = va_arg(ap, int);
	ld	hl, #8
	add	hl, sp
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, 10 (ix)
	add	a, #0x02
	ld	-14 (ix), a
	ld	a, 11 (ix)
	adc	a, #0x00
	ld	-13 (ix), a
	ld	a, -14 (ix)
	ld	10 (ix), a
	ld	a, -13 (ix)
	ld	11 (ix), a
	ld	a, -14 (ix)
	add	a, #0xfe
	ld	-11 (ix), a
	ld	a, -13 (ix)
	adc	a, #0xff
	ld	-10 (ix), a
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	ld	a, (hl)
	ld	-11 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-10 (ix), a
	ld	a, -11 (ix)
	ld	-47 (ix), a
	ld	a, -10 (ix)
	ld	-46 (ix), a
	rla
	sbc	a, a
	ld	-45 (ix), a
	ld	-44 (ix), a
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0004
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../printf_large.c:741: if (!signed_argument)
	bit	0, -16 (ix)
	jr	NZ,00173$
;../printf_large.c:743: value.l &= 0xFFFF;
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0000
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	ld	a, -51 (ix)
	ld	-47 (ix), a
	ld	a, -50 (ix)
	ld	-46 (ix), a
	ld	-45 (ix), #0x00
	ld	-44 (ix), #0x00
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0004
	add	hl, sp
	ld	bc, #0x0004
	ldir
00173$:
;../printf_large.c:747: if ( signed_argument )
	bit	0, -16 (ix)
	jr	Z,00178$
;../printf_large.c:749: if (value.l < 0)
	ld	hl, #8
	add	hl, sp
	ld	-2 (ix), l
	ld	-1 (ix), h
	ex	de,hl
	ld	hl, #0x0004
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	bit	7, -44 (ix)
	jr	Z,00175$
;../printf_large.c:750: value.l = -value.l;
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0000
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	xor	a, a
	sub	a, -51 (ix)
	ld	-47 (ix), a
	ld	a, #0x00
	sbc	a, -50 (ix)
	ld	-46 (ix), a
	ld	a, #0x00
	sbc	a, -49 (ix)
	ld	-45 (ix), a
	ld	a, #0x00
	sbc	a, -48 (ix)
	ld	-44 (ix), a
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0004
	add	hl, sp
	ld	bc, #0x0004
	ldir
	jr	00178$
00175$:
;../printf_large.c:752: signed_argument = 0;
	ld	-16 (ix), #0x00
00178$:
;../printf_large.c:756: lsd = 1;
	ld	-1 (ix), #0x01
;../printf_large.c:758: do {
	ld	c, -8 (ix)
	ld	b, -7 (ix)
	ld	-8 (ix), #0x00
	ld	-7 (ix), #0x00
00182$:
;../printf_large.c:759: value.byte[4] = 0;
	ld	hl, #12
	add	hl, sp
	ld	(hl), #0x00
;../printf_large.c:761: calculate_digit(&value, radix);
	ld	e, -28 (ix)
	ld	d, -27 (ix)
	push	bc
	ld	a, -12 (ix)
	push	af
	inc	sp
	push	de
	call	_calculate_digit
	pop	af
	inc	sp
	pop	bc
;../printf_large.c:765: if (!lsd)
	bit	0, -1 (ix)
	jr	NZ,00180$
;../printf_large.c:767: *pstore = (value.byte[4] << 4) | (value.byte[4] >> 4) | *pstore;
	ld	l, -24 (ix)
	ld	h, -23 (ix)
	ld	a, (hl)
	add	a, a
	add	a, a
	add	a, a
	add	a, a
	ld	e, a
	ld	l, -24 (ix)
	ld	h, -23 (ix)
	ld	a, (hl)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
	or	a, e
	ld	e, a
	ld	a, (bc)
	or	a, e
	ld	(bc), a
;../printf_large.c:768: pstore--;
	dec	bc
	jr	00181$
00180$:
;../printf_large.c:772: *pstore = value.byte[4];
	ld	l, -26 (ix)
	ld	h, -25 (ix)
	ld	a, (hl)
	ld	(bc), a
00181$:
;../printf_large.c:774: length++;
	inc	-8 (ix)
	jr	NZ,00663$
	inc	-7 (ix)
00663$:
;../printf_large.c:775: lsd = !lsd;
	ld	a, -1 (ix)
	xor	a, #0x01
	ld	-1 (ix), a
;../printf_large.c:776: } while( value.ul );
	ld	l, -28 (ix)
	ld	h, -27 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	inc	hl
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	or	a, l
	or	a, d
	or	a, e
	jr	NZ,00182$
;../printf_large.c:778: if (width == 0)
	ld	-13 (ix), c
	ld	-12 (ix), b
	ld	a, -8 (ix)
	ld	-11 (ix), a
	ld	a, -7 (ix)
	ld	-10 (ix), a
	ld	a, -3 (ix)
	or	a, -4 (ix)
	jr	NZ,00186$
;../printf_large.c:783: width = 1;
	ld	-4 (ix), #0x01
	ld	-3 (ix), #0x00
00186$:
;../printf_large.c:787: if (!zero_padding && !left_justify)
	bit	0, -19 (ix)
	jr	NZ,00191$
	bit	0, -20 (ix)
	jr	NZ,00191$
;../printf_large.c:789: while ( width > (unsigned char) (length+1) )
	ld	a, -4 (ix)
	ld	-8 (ix), a
	ld	a, -3 (ix)
	ld	-7 (ix), a
00187$:
	ld	a, -11 (ix)
	ld	-2 (ix), a
	inc	-2 (ix)
	ld	a, -2 (ix)
	ld	-3 (ix), a
	ld	-2 (ix), #0x00
	ld	a, -3 (ix)
	sub	a, -8 (ix)
	ld	a, -2 (ix)
	sbc	a, -7 (ix)
	jr	NC,00316$
;../printf_large.c:791: OUTPUT_CHAR( ' ', p );
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x20
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jr	NZ,00664$
	inc	-5 (ix)
00664$:
;../printf_large.c:792: width--;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	dec	hl
	ld	-8 (ix), l
	ld	-7 (ix), h
	jr	00187$
00316$:
	ld	a, -8 (ix)
	ld	-4 (ix), a
	ld	a, -7 (ix)
	ld	-3 (ix), a
00191$:
;../printf_large.c:796: if (signed_argument) // this now means the original value was negative
	bit	0, -16 (ix)
	jr	Z,00201$
;../printf_large.c:798: OUTPUT_CHAR( '-', p );
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x2d
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jr	NZ,00665$
	inc	-5 (ix)
00665$:
;../printf_large.c:800: width--;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	dec	hl
	ld	-4 (ix), l
	ld	-3 (ix), h
	jr	00202$
00201$:
;../printf_large.c:802: else if (length != 0)
	ld	a, -10 (ix)
	or	a, -11 (ix)
	jr	Z,00202$
;../printf_large.c:805: if (prefix_sign)
	bit	0, -18 (ix)
	jr	Z,00196$
;../printf_large.c:807: OUTPUT_CHAR( '+', p );
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x2b
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jr	NZ,00666$
	inc	-5 (ix)
00666$:
;../printf_large.c:809: width--;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	dec	hl
	ld	-4 (ix), l
	ld	-3 (ix), h
	jr	00202$
00196$:
;../printf_large.c:811: else if (prefix_space)
	bit	0, -17 (ix)
	jr	Z,00202$
;../printf_large.c:813: OUTPUT_CHAR( ' ', p );
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x20
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jr	NZ,00667$
	inc	-5 (ix)
00667$:
;../printf_large.c:815: width--;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	dec	hl
	ld	-4 (ix), l
	ld	-3 (ix), h
00202$:
;../printf_large.c:820: if (!left_justify)
	bit	0, -20 (ix)
	jr	NZ,00210$
;../printf_large.c:822: while ( width-- > length )
	ld	a, -4 (ix)
	ld	-8 (ix), a
	ld	a, -3 (ix)
	ld	-7 (ix), a
00203$:
	ld	c, -8 (ix)
	ld	b, -7 (ix)
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	dec	hl
	ld	-8 (ix), l
	ld	-7 (ix), h
	ld	a, -11 (ix)
	sub	a, c
	ld	a, -10 (ix)
	sbc	a, b
	jr	NC,00317$
;../printf_large.c:824: OUTPUT_CHAR( zero_padding ? '0' : ' ', p );
	bit	0, -19 (ix)
	jr	Z,00236$
	ld	-3 (ix), #0x30
	ld	-2 (ix), #0x00
	jr	00237$
00236$:
	ld	-3 (ix), #0x20
	ld	-2 (ix), #0x00
00237$:
	ld	b, -3 (ix)
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	push	bc
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jr	NZ,00203$
	inc	-5 (ix)
	jr	00203$
00210$:
;../printf_large.c:830: if (width > length)
	ld	a, -11 (ix)
	sub	a, -4 (ix)
	ld	a, -10 (ix)
	sbc	a, -3 (ix)
	jr	NC,00207$
;../printf_large.c:831: width -= length;
	ld	a, -4 (ix)
	sub	a, -11 (ix)
	ld	-8 (ix), a
	ld	a, -3 (ix)
	sbc	a, -10 (ix)
	ld	-7 (ix), a
	jr	00309$
00207$:
;../printf_large.c:833: width = 0;
	ld	-8 (ix), #0x00
	ld	-7 (ix), #0x00
;../printf_large.c:872: return charsOutputted;
;../printf_large.c:837: while( length-- )
00317$:
00309$:
	ld	a, -13 (ix)
	ld	-3 (ix), a
	ld	a, -12 (ix)
	ld	-2 (ix), a
	ld	a, -6 (ix)
	ld	-13 (ix), a
	ld	a, -5 (ix)
	ld	-12 (ix), a
	ld	a, -11 (ix)
	ld	-5 (ix), a
	ld	a, -10 (ix)
	ld	-4 (ix), a
00215$:
	ld	a, -5 (ix)
	ld	-11 (ix), a
	ld	a, -4 (ix)
	ld	-10 (ix), a
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	dec	hl
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	a, -10 (ix)
	or	a, -11 (ix)
	jr	Z,00318$
;../printf_large.c:839: lsd = !lsd;
	ld	a, -1 (ix)
	xor	a, #0x01
	ld	-1 (ix), a
;../printf_large.c:840: if (!lsd)
	bit	0, -1 (ix)
	jr	NZ,00213$
;../printf_large.c:842: pstore++;
	inc	-3 (ix)
	jr	NZ,00669$
	inc	-2 (ix)
00669$:
;../printf_large.c:843: value.byte[4] = *pstore >> 4;
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	ld	a, (hl)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
	ld	l, -26 (ix)
	ld	h, -25 (ix)
	ld	(hl), a
	jr	00214$
00213$:
;../printf_large.c:847: value.byte[4] = *pstore & 0x0F;
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	ld	a, (hl)
	and	a, #0x0f
	ld	l, -26 (ix)
	ld	h, -25 (ix)
	ld	(hl), a
00214$:
;../printf_large.c:850: output_digit( value.byte[4], lower_case, output_char, p );
	ld	l, -22 (ix)
	ld	h, -21 (ix)
	ld	b, (hl)
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	ld	a, -9 (ix)
	push	af
	inc	sp
	push	bc
	inc	sp
	call	_output_digit
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;../printf_large.c:851: charsOutputted++;
	inc	-13 (ix)
	jp	NZ,00215$
	inc	-12 (ix)
	jp	00215$
00318$:
	ld	a, -13 (ix)
	ld	-6 (ix), a
	ld	a, -12 (ix)
	ld	-5 (ix), a
;../printf_large.c:856: if (left_justify)
	bit	0, -20 (ix)
	jp	Z, 00231$
;../printf_large.c:858: while (width-- > 0)
	ld	a, -13 (ix)
	ld	-2 (ix), a
	ld	a, -12 (ix)
	ld	-1 (ix), a
	ld	a, -8 (ix)
	ld	-4 (ix), a
	ld	a, -7 (ix)
	ld	-3 (ix), a
00218$:
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	dec	hl
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	a, b
	or	a, c
	jp	Z, 00231$
;../printf_large.c:860: OUTPUT_CHAR(' ', p);
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, #0x20
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-2 (ix)
	jr	NZ,00671$
	inc	-1 (ix)
00671$:
	ld	a, -2 (ix)
	ld	-6 (ix), a
	ld	a, -1 (ix)
	ld	-5 (ix), a
	jr	00218$
00229$:
;../printf_large.c:868: OUTPUT_CHAR( c, p );
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	a, -1 (ix)
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	inc	-6 (ix)
	jp	NZ,00231$
	inc	-5 (ix)
	jp	00231$
00233$:
;../printf_large.c:872: return charsOutputted;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
;../printf_large.c:873: }
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "<NO FLOAT>"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
