;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module qsort
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _qsort
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../qsort.c:33: static void swap(void *restrict dst, void *restrict src, size_t n)
;	---------------------------------
; Function swap
; ---------------------------------
_swap:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	dec	sp
;../qsort.c:35: unsigned char *restrict d = dst;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
;../qsort.c:36: unsigned char *restrict s = src;
	ld	a, 6 (ix)
	ld	-2 (ix), a
	ld	a, 7 (ix)
	ld	-1 (ix), a
;../qsort.c:38: while(n--)
	ld	c, 8 (ix)
	ld	b, 9 (ix)
00101$:
	ld	l, c
	ld	h, b
	dec	bc
	ld	a, h
	or	a, l
	jr	Z,00104$
;../qsort.c:40: unsigned char tmp = *d;
	ld	a, (de)
	ld	-3 (ix), a
;../qsort.c:41: *d = *s;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, (hl)
	ld	(de), a
;../qsort.c:42: *s = tmp;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, -3 (ix)
	ld	(hl), a
;../qsort.c:43: d++;
	inc	de
;../qsort.c:44: s++;
	inc	-2 (ix)
	jr	NZ,00101$
	inc	-1 (ix)
	jr	00101$
00104$:
;../qsort.c:46: }
	ld	sp, ix
	pop	ix
	ret
;../qsort.c:48: void qsort(void *base, size_t nmemb, size_t size, int (*compar)(const void *, const void *) __reentrant)
;	---------------------------------
; Function qsort
; ---------------------------------
_qsort::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;../qsort.c:50: unsigned char *b = base;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	inc	sp
	inc	sp
	push	bc
;../qsort.c:52: if(nmemb <= 1)
	ld	a, #0x01
	cp	a, 6 (ix)
	ld	a, #0x00
	sbc	a, 7 (ix)
;../qsort.c:53: return;
	jp	NC,00112$
;../qsort.c:55: for(unsigned char *i = base; i < b + nmemb * size; i += size)
	ld	e, 8 (ix)
	ld	d, 9 (ix)
	push	bc
	push	de
	push	de
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	call	__mulint
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	a, -8 (ix)
	add	a, l
	ld	-6 (ix), a
	ld	a, -7 (ix)
	adc	a, h
	ld	-5 (ix), a
00110$:
	ld	a, c
	sub	a, -6 (ix)
	ld	a, b
	sbc	a, -5 (ix)
	jr	NC,00112$
;../qsort.c:57: for(unsigned char *j = i; (j > b) && (*compar)(j, j - size) < 0; j -= size)
	ld	l, c
	ld	h, b
00107$:
	ld	a, -8 (ix)
	sub	a, l
	ld	a, -7 (ix)
	sbc	a, h
	jr	NC,00111$
	ld	a, l
	sub	a, e
	ld	-4 (ix), a
	ld	a, h
	sbc	a, d
	ld	-3 (ix), a
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	pop	iy
	pop	hl
	ld	-2 (ix), l
	ld	-1 (ix), h
	push	bc
	push	de
	push	iy
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, 10 (ix)
	ld	h, 11 (ix)
	call	___sdcc_call_hl
	pop	af
	pop	af
	pop	de
	pop	bc
	bit	7, h
	jr	Z,00111$
;../qsort.c:58: swap(j, j - size, size);
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	bc
	push	de
	push	de
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_swap
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	de
	pop	bc
;../qsort.c:57: for(unsigned char *j = i; (j > b) && (*compar)(j, j - size) < 0; j -= size)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	jr	00107$
00111$:
;../qsort.c:55: for(unsigned char *i = base; i < b + nmemb * size; i += size)
	ld	a, c
	add	a, e
	ld	c, a
	ld	a, b
	adc	a, d
	ld	b, a
	jr	00110$
00112$:
;../qsort.c:60: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
