;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module sincosf
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _sincosf
	.globl _fabsf
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../sincosf.c:50: float sincosf(float x, bool iscos)
;	---------------------------------
; Function sincosf
; ---------------------------------
_sincosf::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-13
	add	hl, sp
	ld	sp, hl
;../sincosf.c:56: if(iscos)
	bit	0, 8 (ix)
	jr	Z,00105$
;../sincosf.c:58: y=fabsf(x)+HALF_PI;
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_fabsf
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0x3fc9
	push	hl
	ld	hl, #0x0fdb
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
;../sincosf.c:59: sign=0;
	ld	-1 (ix), #0x00
	jr	00106$
00105$:
;../sincosf.c:63: if(x<0.0)
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00102$
;../sincosf.c:64: { y=-x; sign=1; }
	ld	a, 7 (ix)
	xor	a,#0x80
	ld	-3 (ix), a
	ld	a, 4 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	ld	-5 (ix), a
	ld	a, 6 (ix)
	ld	-4 (ix), a
	ld	-1 (ix), #0x01
	jr	00106$
00102$:
;../sincosf.c:66: { y=x; sign=0; }
	ld	hl, #7
	add	hl, sp
	ex	de, hl
	ld	hl, #17
	add	hl, sp
	ld	bc, #4
	ldir
	ld	-1 (ix), #0x00
00106$:
;../sincosf.c:69: if(y>YMAX)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	hl, #0x4649
	push	hl
	ld	hl, #0x0c00
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	a, l
	or	a, a
	jr	Z,00108$
;../sincosf.c:71: errno=ERANGE;
	ld	hl, #0x0022
	ld	(_errno), hl
;../sincosf.c:72: return 0.0;
	ld	hl,#0x0000
	ld	e,l
	ld	d,h
	jp	00115$
00108$:
;../sincosf.c:76: N=((y*iPI)+0.5); /*y is positive*/
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	hl, #0x3ea2
	push	hl
	ld	hl, #0xf983
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	hl, #0x3f00
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	push	de
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	call	___fs2sint
	pop	af
	pop	af
	ld	-3 (ix), l
	ld	-2 (ix), h
	ld	c, l
	ld	b, h
;../sincosf.c:79: if(N&1) sign=!sign;
	bit	0, c
	jr	Z,00110$
	ld	a, -1 (ix)
	xor	a, #0x01
	ld	-1 (ix), a
00110$:
;../sincosf.c:81: XN=N;
	push	bc
	call	___sint2fs
	pop	af
	ld	-13 (ix), l
	ld	-12 (ix), h
	ld	-11 (ix), e
	ld	-10 (ix), d
;../sincosf.c:83: if(iscos) XN-=0.5;
	bit	0, 8 (ix)
	jr	Z,00112$
	ld	hl, #0x3f00
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	hl, #0
	add	hl, sp
	ex	de, hl
	ld	hl, #8
	add	hl, sp
	ld	bc, #4
	ldir
00112$:
;../sincosf.c:85: y=fabsf(x);
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_fabsf
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../sincosf.c:86: r=(int)y;
	push	bc
	push	de
	push	de
	push	bc
	call	___fs2sint
	pop	af
	ex	(sp),hl
	call	___sint2fs
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	pop	de
	pop	bc
	ld	a, -5 (ix)
	ld	-9 (ix), a
	ld	a, -4 (ix)
	ld	-8 (ix), a
	ld	a, -3 (ix)
	ld	-7 (ix), a
	ld	a, -2 (ix)
	ld	-6 (ix), a
;../sincosf.c:87: g=y-r;
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	push	hl
	push	de
	push	bc
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
;../sincosf.c:88: f=((r-XN*C1)+g)-XN*C2;
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	hl, #0x4049
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	hl, #0x3a7d
	push	hl
	ld	hl, #0xaa22
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	hl, #3
	add	hl, sp
	ex	de, hl
	ld	hl, #8
	add	hl, sp
	ld	bc, #4
	ldir
;../sincosf.c:90: g=f*f;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
;../sincosf.c:91: if(g>EPS2) //Used to be if(fabsf(f)>EPS)
	ld	-4 (ix), e
	ld	-3 (ix), d
	push	de
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	hl, #0x337f
	push	hl
	ld	hl, #0xfff3
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	a, l
	or	a, a
	jp	Z, 00114$
;../sincosf.c:93: r=(((r4*g+r3)*g+r2)*g+r1)*g;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	hl, #0x362e
	push	hl
	ld	hl, #0x9c5b
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0xb94f
	push	hl
	ld	hl, #0xb222
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	push	de
	push	bc
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0x3c08
	push	hl
	ld	hl, #0x873e
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	push	de
	push	bc
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0xbe2a
	push	hl
	ld	hl, #0xaaa4
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	push	de
	push	bc
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
;../sincosf.c:94: f+=f*r;
	push	hl
	push	de
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	-4 (ix), h
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	hl, #3
	add	hl, sp
	ex	de, hl
	ld	hl, #8
	add	hl, sp
	ld	bc, #4
	ldir
00114$:
;../sincosf.c:96: return (sign?-f:f);
	bit	0, -1 (ix)
	jr	Z,00117$
	ld	a, -7 (ix)
	xor	a,#0x80
	ld	-1 (ix), a
	ld	a, -10 (ix)
	ld	-4 (ix), a
	ld	a, -9 (ix)
	ld	-3 (ix), a
	ld	a, -8 (ix)
	ld	-2 (ix), a
	jr	00118$
00117$:
	ld	hl, #9
	add	hl, sp
	ex	de, hl
	ld	hl, #3
	add	hl, sp
	ld	bc, #4
	ldir
00118$:
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
00115$:
;../sincosf.c:97: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
