;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module sqrtf
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _ldexpf
	.globl _frexpf
	.globl _sqrtf
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../sqrtf.c:37: float sqrtf(float x) _FLOAT_FUNC_REENTRANT
;	---------------------------------
; Function sqrtf
; ---------------------------------
_sqrtf::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;../sqrtf.c:42: if (x==0.0) return x;
	ld	a, 7 (ix)
	res	7, a
	or	a, 6 (ix)
	or	a, 5 (ix)
	or	a, 4 (ix)
	jr	NZ,00107$
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	e, 6 (ix)
	ld	d, 7 (ix)
	jp	00111$
00107$:
;../sqrtf.c:43: else if (x==1.0) return 1.0;
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fseq
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00104$
	ld	hl, #0x0000
	ld	de, #0x3f80
	jp	00111$
00104$:
;../sqrtf.c:44: else if (x<0.0)
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00108$
;../sqrtf.c:46: errno=EDOM;
	ld	hl, #0x0021
	ld	(_errno), hl
;../sqrtf.c:47: return 0.0;
	ld	hl,#0x0000
	ld	e,l
	ld	d,h
	jp	00111$
00108$:
;../sqrtf.c:49: f=frexpf(x, &n);
	ld	hl, #8
	add	hl, sp
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_frexpf
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
;../sqrtf.c:50: y=0.41731+0.59016*f; /*Educated guess*/
	ld	-8 (ix), e
	ld	-7 (ix), d
	push	de
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	hl, #0x3f17
	push	hl
	ld	hl, #0x14ba
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0x3ed5
	push	hl
	ld	hl, #0xa9a8
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../sqrtf.c:52: y+=f/y;
	push	bc
	push	de
	push	de
	push	bc
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	pop	de
	pop	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
;../sqrtf.c:53: y=ldexpf(y, -2) + f/y; /*Faster version of 0.25 * y + f/y*/
	push	hl
	push	de
	ld	bc, #0xfffe
	push	bc
	push	hl
	push	de
	call	_ldexpf
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../sqrtf.c:55: if (n&1)
	bit	0, -2 (ix)
	jr	Z,00110$
;../sqrtf.c:57: y*=0.7071067812;
	push	de
	push	bc
	ld	hl, #0x3f35
	push	hl
	ld	hl, #0x04f3
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../sqrtf.c:58: ++n;
	inc	-2 (ix)
	jr	NZ,00140$
	inc	-1 (ix)
00140$:
00110$:
;../sqrtf.c:60: return ldexpf(y, n/2);
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	bit	7, h
	jr	Z,00113$
	inc	hl
00113$:
	sra	h
	rr	l
	push	hl
	push	de
	push	bc
	call	_ldexpf
	pop	af
	pop	af
	pop	af
00111$:
;../sqrtf.c:61: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
